Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4671)
@@ -3867,66 +3968,66 @@
                                  drho_air_zw(k-1)
                 ENDDO
-             ENDDO
-!
-!--          Treat horizontal natural surfaces
-             surf_s = surf_lsm_h%start_index(j,i)
-             surf_e = surf_lsm_h%end_index(j,i)
-             DO  m = surf_s, surf_e
-                k = surf_lsm_h%k(m)
-
-                IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ELSE IF ( bulk_cloud_model )  THEN
-                   IF ( ql(k,j,i) == 0.0_wp )  THEN
+!
+!--             natural surfaces
+                surf_s = surf_lsm_h(l)%start_index(j,i)
+                surf_e = surf_lsm_h(l)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k = surf_lsm_h(l)%k(m)
+
+                   IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
                       k1 = 1.0_wp + 0.61_wp * q(k,j,i)
                       k2 = 0.61_wp * pt(k,j,i)
-                   ELSE
-                      theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
-                      temp  = theta * exner(k)
-                      k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *              &
-                           ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                               &
-                           ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                                &
-                           ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                      k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                   ELSE IF ( bulk_cloud_model )  THEN
+                      IF ( ql(k,j,i) == 0.0_wp )  THEN
+                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                         k2 = 0.61_wp * pt(k,j,i)
+                      ELSE
+                         theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
+                         temp  = theta * exner(k)
+                         k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *              &
+                              ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                               &
+                              ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                                &
+                              ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                         k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                      ENDIF
+                   ELSE IF ( cloud_droplets )  THEN
+                      k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                      k2 = 0.61_wp * pt(k,j,i)
                    ENDIF
-                ELSE IF ( cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ENDIF
-
-                tmp_flux(k) = ( k1 * surf_lsm_h%shf(m) + k2 * surf_lsm_h%qsws(m) ) *               &
-                              drho_air_zw(k-1)
-             ENDDO
-!
-!--          Treat horizontal urban surfaces
-             surf_s = surf_usm_h%start_index(j,i)
-             surf_e = surf_usm_h%end_index(j,i)
-             DO  m = surf_s, surf_e
-                k = surf_usm_h%k(m)
-
-                IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ELSE IF ( bulk_cloud_model )  THEN
-                   IF ( ql(k,j,i) == 0.0_wp )  THEN
+
+                   tmp_flux(k) = ( k1 * surf_lsm_h(l)%shf(m) + k2 * surf_lsm_h(l)%qsws(m) ) *         &
+                                 drho_air_zw(k-1)
+                ENDDO
+!
+!--             urban surfaces
+                surf_s = surf_usm_h(l)%start_index(j,i)
+                surf_e = surf_usm_h(l)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k = surf_usm_h(l)%k(m)
+
+                   IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
                       k1 = 1.0_wp + 0.61_wp * q(k,j,i)
                       k2 = 0.61_wp * pt(k,j,i)
-                   ELSE
-                      theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
-                      temp  = theta * exner(k)
-                      k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *              &
-                           ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                               &
-                           ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                                &
-                           ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                      k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                   ELSE IF ( bulk_cloud_model )  THEN
+                      IF ( ql(k,j,i) == 0.0_wp )  THEN
+                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                         k2 = 0.61_wp * pt(k,j,i)
+                      ELSE
+                         theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
+                         temp  = theta * exner(k)
+                         k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *              &
+                              ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                               &
+                              ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                                &
+                              ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                         k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                      ENDIF
+                   ELSE IF ( cloud_droplets )  THEN
+                      k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                      k2 = 0.61_wp * pt(k,j,i)
                    ENDIF
-                ELSE IF ( cloud_droplets )  THEN
-                   k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                   k2 = 0.61_wp * pt(k,j,i)
-                ENDIF
-
-                tmp_flux(k) = ( k1 * surf_usm_h%shf(m) + k2 * surf_usm_h%qsws(m) ) *               &
-                              drho_air_zw(k-1)
+
+                   tmp_flux(k) = ( k1 * surf_usm_h(l)%shf(m) + k2 * surf_usm_h(l)%qsws(m) ) *         &
+                                 drho_air_zw(k-1)
+                ENDDO
              ENDDO
 
@@ -4610,6 +4711,6 @@
     INTEGER(iwp) ::  j  !< loop index
     INTEGER(iwp) ::  k  !< loop index
+    INTEGER(iwp) ::  l  !< loop index
     INTEGER(iwp) ::  m  !< loop index
-    INTEGER(iwp) ::  n  !< loop index
 
     REAL(wp) ::  var_reference  !< reference temperature
@@ -4647,49 +4748,49 @@
 !--    Upward facing surfaces
 !--    Default surfaces
-       n = 0
-       !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-       DO  m = 1, surf_def_h(0)%ns
-          i = surf_def_h(0)%i(m)
-          j = surf_def_h(0)%j(m)
-          k = surf_def_h(0)%k(m)
-          km(k,j,i) = kappa * surf_def_h(0)%us(m) * surf_def_h(0)%z_mo(m) /                        &
-                      phi_m( surf_def_h(0)%z_mo(m) / surf_def_h(0)%ol(m) )
-          kh(k,j,i) = 1.35_wp * km(k,j,i)
+       DO l = 0, 1
+          !$OMP PARALLEL DO PRIVATE(i,j,k,m)
+          DO  m = 1, surf_def_h(l)%ns
+             i = surf_def_h(l)%i(m)
+             j = surf_def_h(l)%j(m)
+             k = surf_def_h(l)%k(m)
+             km(k,j,i) = kappa * surf_def_h(l)%us(m) * surf_def_h(l)%z_mo(m) /                        &
+                         phi_m( surf_def_h(l)%z_mo(m) / surf_def_h(l)%ol(m) )
+             kh(k,j,i) = 1.35_wp * km(k,j,i)
+          ENDDO
+!
+!--       Natural surfaces
+          !$OMP PARALLEL DO PRIVATE(i,j,k,m)
+          DO  m = 1, surf_lsm_h(l)%ns
+             i = surf_lsm_h(l)%i(m)
+             j = surf_lsm_h(l)%j(m)
+             k = surf_lsm_h(l)%k(m)
+             km(k,j,i) = kappa * surf_lsm_h(l)%us(m) * surf_lsm_h(l)%z_mo(m) /                              &
+                         phi_m( surf_lsm_h(l)%z_mo(m) / surf_lsm_h(l)%ol(m) )
+             kh(k,j,i) = 1.35_wp * km(k,j,i)
+          ENDDO
+!
+!--       Urban surfaces
+          !$OMP PARALLEL DO PRIVATE(i,j,k,m)
+          DO  m = 1, surf_usm_h(l)%ns
+             i = surf_usm_h(l)%i(m)
+             j = surf_usm_h(l)%j(m)
+             k = surf_usm_h(l)%k(m)
+             km(k,j,i) = kappa * surf_usm_h(l)%us(m) * surf_usm_h(l)%z_mo(m) /                              &
+                         phi_m( surf_usm_h(l)%z_mo(m) / surf_usm_h(l)%ol(m) )
+             kh(k,j,i) = 1.35_wp * km(k,j,i)
+          ENDDO
        ENDDO
-!
-!--    Natural surfaces
-       !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m)
-          j = surf_lsm_h%j(m)
-          k = surf_lsm_h%k(m)
-          km(k,j,i) = kappa * surf_lsm_h%us(m) * surf_lsm_h%z_mo(m) /                              &
-                      phi_m( surf_lsm_h%z_mo(m) / surf_lsm_h%ol(m) )
-          kh(k,j,i) = 1.35_wp * km(k,j,i)
-       ENDDO
-!
-!--    Urban surfaces
-       !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-       DO  m = 1, surf_usm_h%ns
-          i = surf_usm_h%i(m)
-          j = surf_usm_h%j(m)
-          k = surf_usm_h%k(m)
-          km(k,j,i) = kappa * surf_usm_h%us(m) * surf_usm_h%z_mo(m) /                              &
-                      phi_m( surf_usm_h%z_mo(m) / surf_usm_h%ol(m) )
-          kh(k,j,i) = 1.35_wp * km(k,j,i)
-       ENDDO
-
 !
 !--    North-, south-, west and eastward facing surfaces
 !--    Do not consider stratification at these surfaces.
-       DO  n = 0, 3
+       DO  l = 0, 3
 !
 !--       Default surfaces
           !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-          DO  m = 1, surf_def_v(n)%ns
-             i = surf_def_v(n)%i(m)
-             j = surf_def_v(n)%j(m)
-             k = surf_def_v(n)%k(m)
-             km(k,j,i) = kappa * surf_def_v(n)%us(m) * surf_def_v(n)%z_mo(m)
+          DO  m = 1, surf_def_v(l)%ns
+             i = surf_def_v(l)%i(m)
+             j = surf_def_v(l)%j(m)
+             k = surf_def_v(l)%k(m)
+             km(k,j,i) = kappa * surf_def_v(l)%us(m) * surf_def_v(l)%z_mo(m)
              kh(k,j,i) = 1.35_wp * km(k,j,i)
           ENDDO
@@ -4697,9 +4798,9 @@
 !--       Natural surfaces
           !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-          DO  m = 1, surf_lsm_v(n)%ns
-             i = surf_lsm_v(n)%i(m)
-             j = surf_lsm_v(n)%j(m)
-             k = surf_lsm_v(n)%k(m)
-             km(k,j,i) = kappa * surf_lsm_v(n)%us(m) * surf_lsm_v(n)%z_mo(m)
+          DO  m = 1, surf_lsm_v(l)%ns
+             i = surf_lsm_v(l)%i(m)
+             j = surf_lsm_v(l)%j(m)
+             k = surf_lsm_v(l)%k(m)
+             km(k,j,i) = kappa * surf_lsm_v(l)%us(m) * surf_lsm_v(l)%z_mo(m)
              kh(k,j,i) = 1.35_wp * km(k,j,i)
           ENDDO
@@ -4707,9 +4808,9 @@
 !--       Urban surfaces
           !$OMP PARALLEL DO PRIVATE(i,j,k,m)
-          DO  m = 1, surf_usm_v(n)%ns
-             i = surf_usm_v(n)%i(m)
-             j = surf_usm_v(n)%j(m)
-             k = surf_usm_v(n)%k(m)
-             km(k,j,i) = kappa * surf_usm_v(n)%us(m) * surf_usm_v(n)%z_mo(m)
+          DO  m = 1, surf_usm_v(l)%ns
+             i = surf_usm_v(l)%i(m)
+             j = surf_usm_v(l)%j(m)
+             k = surf_usm_v(l)%k(m)
+             km(k,j,i) = kappa * surf_usm_v(l)%us(m) * surf_usm_v(l)%z_mo(m)
              kh(k,j,i) = 1.35_wp * km(k,j,i)
           ENDDO
